/*
 * Interface for lexical tokens returned by calculator scanner
 * CSE 303 HW6, Sp08, Wi09, CSE 374 HW6 Sp09
 * HP, 5/08, 3/09, 5/09
 */

#ifndef TOKEN_H
#define TOKEN_H

// lexical classes
enum lex_class {
  UNKNOWN,          // illegal or unknown character
  INT,              // integer constant
  PLUS,             // operator +
  MINUS,            // operator -
  TIMES,            // operator *
  DIV,              // operator %
  SLASH,            // slash to separate numerator/denominator
  LPAREN,           // (
  RPAREN,           // )
  EOL               // end of input line
};

// lexical token returned by scanner
struct token {
  lex_class kind;   // lexical class of the token
  int       ival;   // integer value if kind == INT (undefined otherwise)
};

#endif
